package gui;

import vs.ColorUtils;
import vs.ImageUtils;
import vs.vsFFT;

public class FFTRadix2 {

    FFTFrame parent;

    private ColorUtils CU = new ColorUtils();
    private ImageUtils iUtil = new ImageUtils();
    private vsFFT imgFFT = new vsFFT();

    private short[] imageData_R;
    private short[] imageData_G;
    private short[] imageData_B;


    FFTRadix2(FFTFrame _parent) {

        parent = _parent;
        initData();
    }

    private void initData() {
        imgFFT.DisplayLogPSD = true;
        int w = parent.getWidth();
        int h = parent.getHeight();
        // separated R,G,B values
        //System.out.println("getting the 1-D arrays");
        get1DArraysFromParent();
        //System.out.println("init complete");
    }

    public void get1DArraysFromParent() {
        if (parent == null)
            System.out.println(
                    "ER:get1DArraysFromParent, parent==null");
        if (parent.getWidth() != parent.getHeight())
            System.out.println("ComplexRgb:fft Non-square image detected");
        int N = parent.getWidth() * parent.getHeight();
        imageData_R = new short[N];
        imageData_G = new short[N];
        imageData_B = new short[N];

        for (int x = 0; x < parent.getWidth(); x++)
            for (int y = 0; y < parent.getHeight(); y++) {
                imageData_R[x + y * parent.getWidth()] = parent.getR()[x][y];
                imageData_G[x + y * parent.getWidth()] = parent.getG()[x][y];
                imageData_B[x + y * parent.getWidth()] = parent.getB()[x][y];
            }
    }

    vsFFT vsfft = new vsFFT();

    public int[] fft() {
        vsfft.DisplayLogPSD = true;
        if (parent.getWidth() != parent.getHeight())
            System.out.println("ComplexRgb:fft ER! Non-square image");
        return vsfft.forward2dFFT(
                imageData_R,
                imageData_G,
                imageData_B,
                parent.getWidth(),
                parent.getHeight());
    }

    public void complexMult() {
        for (int x = 0; x < parent.getWidth(); x++)
            for (int y = 0; y < parent.getHeight(); y++) {
                vsfft.cR_r[y][x] *= parent.getR()[x][y] / 255.0;
                vsfft.cR_i[y][x] *= parent.getR()[x][y] / 255.0;
                vsfft.cG_r[y][x] *= parent.getG()[x][y] / 255.0;
                vsfft.cG_i[y][x] *= parent.getG()[x][y] / 255.0;
                vsfft.cB_r[y][x] *= parent.getB()[x][y] / 255.0;
                vsfft.cB_i[y][x] *= parent.getB()[x][y] / 255.0;
            }
    }

    public int[] ifft() {
        return vsfft.reverse2dFFT();
    }


}







