package gui;

import sun.net.ftp.FtpClient;
import vs.WritePPM;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.io.*;
import java.util.zip.GZIPOutputStream;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;

public class SaveFrame extends NegateFrame {
    Menu saveMenu = new Menu("Save");

    MenuItem saveAsJava_mi =
            addMenuItem(saveMenu, "[T-j]ava...");
    MenuItem printIcon_mi =
            addMenuItem(saveMenu, "binary icon...");

    MenuItem saveAsGif_mi =
            addMenuItem(saveMenu, "[T-g]if...(not 24 bit!)");
    MenuItem saveAsPPM_mi =
            addMenuItem(saveMenu, "[T-p]pm...");
    MenuItem saveAsPPMgz_mi =
            addMenuItem(saveMenu, "[T-z]ppm.gz...");
    MenuItem saveAsPPMgzFTP_mi =
            addMenuItem(saveMenu, "saveAsPPMgzFTP");

    MenuItem saveAsShortgz_mi =
            addMenuItem(saveMenu, "[T-s]short.gz...");
    MenuItem saveAsShortZip_mi =
            addMenuItem(saveMenu, "[T-i]saveAsShortZip...");
    MenuItem makeTocHtml_mi =
            addMenuItem(saveMenu, "makeTocHtml...");
    MenuItem print_mi =
            addMenuItem(saveMenu, "print...");


    public void actionPerformed(ActionEvent e) {

        if (match(e, print_mi)) {
            print(this);
            return;
        }
        if (match(e, saveAsPPMgzFTP_mi)) {
            saveAsPPMgzFTP();
            return;
        }
        if (match(e, makeTocHtml_mi)) {
            makeTocHtml();
            return;
        }
        if (match(e, saveAsShortZip_mi)) {
            saveAsShortZip();
            return;
        }
        if (match(e, printIcon_mi)) {
            printIcon();
            return;
        }

        if (match(e, saveAsShortgz_mi)) {
            saveAsShortgz();
            return;
        }
        if (match(e, saveAsPPMgz_mi)) {
            saveAsPPMgz();
            return;
        }
        if (match(e, saveAsPPM_mi)) {
            saveAsPPM();
            return;
        }
        if (match(e, saveAsJava_mi)) {
            saveAsJava();
            return;
        }
        if (match(e, saveAsGif_mi)) {
            saveAsGif();
            return;
        }
        super.actionPerformed(e);

    }

    SaveFrame(String title) {
        super(title);
        getFileMenu().add(saveMenu);
    }

    public static void main(String args[]) {
        System.out.println("Test");
        SaveFrame f = new SaveFrame("save frame");
        f.setVisible(true);
    }


    private static Frame f = new Frame();

    public static void print(Component theView) {
        Toolkit tk = Toolkit.getDefaultToolkit();
        PrintJob printJob =
                tk.getPrintJob(
                        f,
                        "print me!",
                        null);
        Graphics g = printJob.getGraphics();
        theView.paint(g);
        printJob.end();
    }

    public static String getSaveFileName(String prompt) {
        FileDialog fd = new
                FileDialog(f, prompt, FileDialog.SAVE);
        fd.setVisible(true);
        fd.setVisible(false);
        String fn = fd.getDirectory() + fd.getFile();
        if (fd.getFile() == null) return null; //usr canceled
        return fn;
    }

    public String getSaveName(String prompt) {
        FileDialog fd = new
                FileDialog(this, prompt, FileDialog.SAVE);
        fd.setVisible(true);
        fd.setVisible(false);
        String fn = fd.getFile();
        if (fd.getFile() == null) return null; //usr canceled
        return fn;
    }

    public String getSaveDirectoryName(String prompt) {
        FileDialog fd = new
                FileDialog(this, prompt, FileDialog.SAVE);
        fd.setVisible(true);
        fd.setVisible(false);
        return fd.getDirectory();
    }

    public void saveAsPPM() {
        String fn = getSaveFileName("Save as PPM");
        if (fn == null) return;
        saveAsPPM(fn);

    }

    public void saveAsPPM(String fn) {
        vs.WritePPM.doIt(getR(), getG(), getB(), fn);
    }

    public void saveAsPPMgz(String fn) {
        WritePPM wppm = new WritePPM(getWidth(), getHeight());
        Timer t = new Timer();
        t.start();
        try {
            GZIPOutputStream
                    os = new GZIPOutputStream(
                            new FileOutputStream(fn));
            wppm.header(os);
            wppm.image(os, getR(), getG(), getB());
            os.finish();
            os.close();
        } catch (Exception e) {
            System.out.println("Save PPM Exception - 2!");
        }
        t.stop();
        t.print(" saveAsPPMgz in ");
    }

    public void saveAsPPMgz() {
        String fn = getSaveFileName("Save as PPM.gz");
        if (fn == null) return;
        saveAsPPMgz(fn);
    }


    public void saveAsPPMgzFTP() {
        String fileName = getSaveName("Save PPM.gz on FTP server");
        String directory = "/incoming/";
        String hostName = "vinny.bridgeport.edu";
        String userName = "ftpin";
        String password = "ftpin";
        try {
            FtpClient fc =
                    new FtpClient(hostName);
            fc.login(userName, password);
            fc.binary();
            fc.cd(directory);
            OutputStream fos
                    = fc.put(fileName);
            WritePPM wppm = new WritePPM(getWidth(), getHeight());
            try {
                GZIPOutputStream os = new GZIPOutputStream(
                        fos);
                wppm.header(os);
                wppm.image(os, getR(), getG(), getB());
                os.finish();
                os.close();
            } catch (Exception e) {
                println("Save PPM Exception - 2!");
            }
        } catch (IOException e) {
            System.err.println(e);
        }
    }

    public void saveAsShortZip() {
        String fn = getSaveFileName("Save ZIP");
        if (fn == null) return;
        saveAsShortZip(fn);
    }

    public void saveAsShortZip(
            String fn) {
        Timer t = new Timer();
        t.start();
        try {
            FileOutputStream
                    fos = new
                            FileOutputStream(fn);
            ZipOutputStream
                    zos = new
                            ZipOutputStream(fos);
            ZipEntry zer =
                    new ZipEntry("r");
            ZipEntry zeg =
                    new ZipEntry("g");
            ZipEntry zeb =
                    new ZipEntry("b");
            zer.setMethod(
                    ZipEntry.DEFLATED);
            zeg.setMethod(
                    ZipEntry.DEFLATED);
            zeb.setMethod(
                    ZipEntry.DEFLATED);
            zos.putNextEntry(zer);
            ObjectOutputStream
                    oos = new
                            ObjectOutputStream(
                                    zos);
            oos.writeObject(getR());
            zos.putNextEntry(zeg);
            oos.writeObject(getG());
            zos.putNextEntry(zeb);
            oos.writeObject(getB());
            oos.close();
            zos.finish();

        } catch (Exception e) {
            System.out.println("Save saveAsShortZip:" + e);
        }
        t.stop();
        t.print(" saveAsOOSZip in ");
    }

    public void saveAsShortZip2(String fn) {
        Timer t = new Timer();
        t.start();
        try {
            FileOutputStream fos = new FileOutputStream(fn);
            ZipOutputStream zos = new ZipOutputStream(fos);
            DataOutputStream dos = new DataOutputStream(zos);
            ZipEntry ze = new ZipEntry("quad0");
            ze.setMethod(ZipEntry.DEFLATED);
            zos.putNextEntry(ze);
            writeHeader(dos);
            writeArray(getR(), dos);
            writeArray(getG(), dos);
            writeArray(getB(), dos);
            zos.close();
            zos.finish();

        } catch (Exception e) {
            System.out.println("Save saveAsShortZip:" + e);
        }
        t.stop();
        t.print(" saveAsShortZip in ");
    }

    public void writeArray(short a[][], DataOutputStream dos)
            throws IOException {
        for (int x = 0; x < getWidth(); x++)
            for (int y = 0; y < getHeight(); y++)
                dos.writeShort(a[x][y]);
    }

    public void writeHeader(DataOutputStream dos)
            throws IOException {
        dos.writeInt(getWidth());
        dos.writeInt(getHeight());
    }

    public void saveAsShortgz() {
        String fn = getSaveFileName("Save gz");
        if (fn == null) return;
        saveAsShortgz(fn);
    }

    public void saveAsShortgz(String fn) {
        Timer t = new Timer();
        t.start();
        try {
            FileOutputStream fos = new FileOutputStream(fn);
            GZIPOutputStream gos = new GZIPOutputStream(fos);
            ObjectOutputStream
                    oos = new
                            ObjectOutputStream(gos);
            oos.writeObject(getR());
            oos.writeObject(getG());
            oos.writeObject(getB());
            oos.close();
            gos.finish();

        } catch (Exception e) {
            System.out.println("Save saveAsShortgz:" + e);
        }
        t.stop();
        t.print(" saveAsShortgz in ");
    }

    public void saveAsGif() {
        System.out.println("Saving as gif...");
        String fn = getSaveFileName("Save as GIF");
        if (fn == null) return;
        saveAsGif(fn);
    }

    public void saveAsGif(String fn) {
        try {
            vs.WriteGIF.DoIt(
                    getImage(),
                    fn);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void saveAsJava() {
        String fn = getSaveFileName("Save as Java");
        if (fn == null) return;
        saveAsJava(fn);
    }

    public void saveAsxyz() {
        String fn = getSaveFileName("Save as GIF");
        if (fn == null) return;
        saveAsxyz(fn);

    }

    public void saveAsxyz(String fn) {
        try {
            FileWriter fos = new FileWriter(fn);
            PrintWriter pw = new PrintWriter(fos);
            saveAsxyz(pw);
            pw.flush();
            fos.close();
        } catch (Exception e) {
        }
    }

    public FileOutputStream getFileOutputStream(String prompt) {
        FileOutputStream fos = null;
        try {
            fos =
                    new FileOutputStream(getSaveFileName(prompt));
        } catch (IOException e) {
            System.out.println("futil:Could not create file");
        }
        return fos;
    }

    public void makeTocHtml() {
        File dir =
                new File(getSaveDirectoryName("Enter input directory"));

        String[] files = dir.list(new FileFilter());
        System.out.println(files.length + " file(s):");
        FileOutputStream fos = getFileOutputStream(
                "Enter Save File");
        PrintWriter pw = new PrintWriter(fos);
        pw.println("<HTML>");
        pw.println("<BODY>");
        pw.println("<ul>");
        for (int i = 0; i < files.length; i++)
            pw.println("<P><IMG SRC=" + files[i] + "></P>" +
                    "<a>" + files[i] + "</a><P>");
        //ps.println("<LI><a href = \"" + files[i]+"\">"+
        //	files[i]+"</a><P>");
        pw.println("</ul>");
        pw.println("</BODY>");
        pw.println("</HTML>");
        try {
            fos.close();
        } catch (Exception e) {
            System.out.println(e);
        }
    }

    public void saveAsxyz(PrintWriter pw) {
        int y = 0;
        pw.println(0 + " " + 0 + " " + getR()[0][0] + " 0");
        for (int x = 1; x < getWidth(); x++) {
            for (y = 0; y < getHeight(); y++) {
                pw.println(x + " " + y + " " + getR()[x][y] + " 1");
            }
            y = 0;
            pw.println(x + " " + y + " " + getR()[x][y] + " 0");
        }
    }

    public void saveAsJava(String fn) {
        try {
            FileWriter fos =
                    new FileWriter(fn);
            PrintWriter pw =
                    new PrintWriter(fos);
            saveAsJava(pw);
            pw.flush();
            fos.close();
        } catch (Exception e) {
        }
    }

    public void printIcon() {
        int g;
        System.out.println(

                "public static byte iconName[][] = {\n");

        for (int y = 0; y < getHeight(); y++) {
            System.out.print("{");
            for (int x = 0; x < getWidth() - 1; x++) {
                if (getR()[x][y] == 0)
                    g = 0;
                else
                    g = 1;
                System.out.print(g + ",");
            }
            if (getR()[getWidth() - 1][y] == 0)
                g = 0;
            else
                g = 1;
            System.out.println(g + "},");

        }
        System.out.println("};");

    }

    public void saveAsJava(
            PrintWriter pw) {
        int g;
        ProgressFrame pb =
                new ProgressFrame(
                        "writing java...");
        pb.setVisible(true);

        pw.println("package gui;\n"
                + "\nclass NumImage {\n"
                + "\tpublic static short gray[][] = {\n");

        for (int y = 0; y < getHeight(); y++) {
            pw.print("{");
            for (int x = 0; x < getWidth() - 1; x++) {
                g = getR()[x][y];
                if (g < 10)
                    pw.print("  ");
                else if (g < 100) pw.print(" ");
                pw.print(g + ", ");
            }
            pw.println(getR()[getWidth() - 1][y] + "},");
            double percent = (y * 1.0 / getHeight());
            if ((y % 5) == 0)
                pb.setRatioComplete(percent,
                        "Percent done:" + (int) (percent * 100) + "%");
        }
        pw.println("};}");
        System.out.println("Done writing image");
        pb.setVisible(false);
    }

    class FileFilter implements FilenameFilter {
        public boolean accept(File dir, String name) {
            return new File(dir, name).isFile();
        }
    }

}