/* Remote Server*/


package rmiimage;


import java.rmi.RMISecurityManager;
import java.rmi.RemoteException;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;
import java.rmi.server.UnicastRemoteObject;


public class Server
        extends UnicastRemoteObject
        implements BenchMark {
    private String name;

    public Server(String s)
            throws RemoteException {
        super();
        (new Compile()).rmic(); // compile stubs
        name = s;
    }


    public void multiplyBench(long range)
            throws RemoteException {
        long i, product;
        int d1, d2;
        d1 = 2;
        d2 = 3;
        for (i = 0; i < range; i++)
            product = d1 * d2;
    }

    public static void main(String args[]) {
        System.setSecurityManager(new RMISecurityManager());
        Registry r = null;
        try {
            locateAndBind(r);
        } catch (RemoteException e) {
            System.out.println("Server err: " + e.getMessage());
            e.printStackTrace();
        }
    }

    private static void locateAndBind(Registry r)
            throws RemoteException {
        Server obj = new Server("HelloServer");
        r = locateRegistry(r);
        bindRegistry(r, obj);
        System.out.println("HelloServer bound in registry");
    }

    private static void bindRegistry(Registry r, Server obj) {
        try {
            r.rebind("HelloServer", obj);
        } catch (Exception e) {
            System.out.println(e);
        }
    }

    private static Registry locateRegistry(Registry r) {
        try {
            r = LocateRegistry.createRegistry(1099);
        } catch (Exception e) {
            System.out.println(e);
        }
        return r;
    }
}













